/* Kompilator konfiguraku na web
 * (c)14.11.1999 by Marek Zelem
 */

#include <stdlib.h>
#include <string.h>
#include "web_compile.h"

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

char *xstrdup( char *s )
{	if(s==NULL)	return(NULL);
	else		return(strdup(s));
}

char *get_v( out_t *o, char *name, char *def )
{ char *s;
  int next=0;
	s=get_value(o->sekcia.p,name,1,&next);
	if( s==NULL )
		s=get_val(dfifo_data(o->zasobnik),dfifo_n(o->zasobnik),
				name,1,&next);
	if( next )	warning("viacnasobne definovana premenna \"%s\"",name);
	if( s==NULL )	s=def;
	return(s);
}

void generuj_textovu_verziu( out_t *o );

char *spracuj_sekciu( out_t *o )
{ char *s,*p,*rs=NULL;
  int n,next=1,nextf=1;
  char *adr,*prip,*sub,*ps;
  char buf[1024];
  int link;
	adr=get_v(o,"adresar","");
	prip=get_v(o,"pripona","html");
  	n=1;
	while( nextf )
	{	next=nextf=0; link=0;
		s=get_value(o->sekcia.p,"sablona",n,&next);
		if( s==NULL )
		{	s=get_value(o->sekcia.p,"link",n,&next);
			if( s==NULL )
			{	s=get_value(o->sekcia.p,"url",n,&next);
				if( s==NULL )
				{	s=get_value(o->sekcia.p,"copy",n,&next);
					if( s==NULL )
					{	o->err->error(o->err,Evzor,END);
						return(NULL);
					}
					else  link=3;
				}
				else  link=2;
			} else	link=1;
		}
		sub=get_value(o->sekcia.p,"subor",n,&nextf);
		if( next && !nextf )
			o->err->warning(o->err,Wvzor,END);
		if( !next && nextf )
			warning("viacnasobne definovana premenna \"subor\"");
#ifndef ALLOW_MULTI_FILES
		if( nextf )
			warning("viacnasobne definovana premenna \"subor\"");
		if( next )
			warning("viacnasobne definovana premenna \"sablona\"");
#endif ALLOW_MULTI_FILES
		strcpy(buf,adr);
		if( buf[0]!=0 )	strcat(buf,"/");
		ps=buf+strlen(buf);
		if( sub==NULL )
		{	if( link )
			{	if( (p=strrchr(s,'/')) )	strcat(buf,p+1);
				else
				{	error("Nedefinovany \"subor\" (cyklicka linka)");
					return rs;
				}
			}
			else if( o->sekcia.nazov!=NULL )
			{	strcat(buf,o->sekcia.nazov);
				if( prip[0]!=0 )
				{	strcat(buf,".");
					strcat(buf,prip);
				}
			}
			else	buf[0]=0;
		}
		else	strcat(buf,sub);
		if( n==1 && o->sekcia.menu->subor==NULL )
		{	if( link==2 )	o->sekcia.menu->subor=strdup(s);
			else	o->sekcia.menu->subor=strdup(ps);
		}
		if( !link )
		{	s=uprav_vzor(s,&(o->sekcia),dfifo_data(o->zasobnik),
					dfifo_n(o->zasobnik));
			if( s==NULL )
			{	o->err->error(o->err,Euprav_vzor,END);
				return(NULL);
			}
			if( buf[0]!=0 )	data2file(buf,s);
			if( n==1 )	rs=s;
			else		free(s);
		} else if( link==1 )
		{	linkfile(buf,s);
		} else if( link==3 )
		{	copyfile(buf,s);
		} else if( link==2 && sub!=NULL )
			error("Nadbytocne definovny subor");
		if( link )
			o->sekcia.menu->popis=xstrdup(get_value(o->sekcia.p,"nazov",1,&next));
		n++;
	}
	generuj_textovu_verziu(o);
	return(rs);
}

void generuj_textovu_verziu( out_t *o )
{ char *s,*p;
  int n,next=1,nextf=1;
  char *adr,*prip,*sub,*ps;
  char *zdrojsub;
  char buf[1024];
  int link;
	adr=get_v(o,"textova_verzia","");
	if( adr==NULL || adr[0]==0 )
		return;
	prip=get_v(o,"pripona","txt");
  	n=1;
	while( nextf )
	{	next=nextf=0; link=0;
		zdrojsub=NULL;
		s=get_value(o->sekcia.p,"zdroj",n,&next);
		if( s==NULL )
		{	s=get_value(o->sekcia.p,"link",n,&next);
			if( s==NULL )
			{	s=get_value(o->sekcia.p,"url",n,&next);
				if( s==NULL )
				{	s=get_value(o->sekcia.p,"copy",n,&next);
					if( s==NULL )
					{   //	o->err->error(o->err,Evzor,END);
						return;
					}
					else  link=3;
				}
				else  link=2;
			} else	link=1;
		}
		else
		{	ps=s;
			if( (s=file2str(s))==NULL )
			{	s=strdup(ps);
//				warning("Nemozem loadnut subor %s\n",ps);
//				return;
			}
			else	zdrojsub=ps;
		}
		if( zdrojsub!=NULL )
		{	if( (sub=strrchr(zdrojsub,'/'))!=NULL )
				sub+=1;
			else	sub=zdrojsub;
		}
		else
			sub=get_value(o->sekcia.p,"subor",n,&nextf);
/*		if( next && !nextf )
			o->err->warning(o->err,Wvzor,END);
		if( !next && nextf )
			warning("viacnasobne definovana premenna \"subor\"");
#ifndef ALLOW_MULTI_FILES
		if( nextf )
			warning("viacnasobne definovana premenna \"subor\"");
		if( next )
			warning("viacnasobne definovana premenna \"sablona\"");
#endif ALLOW_MULTI_FILES
*/
		strcpy(buf,adr);
		if( buf[0]!=0 )	strcat(buf,"/");
		ps=buf+strlen(buf);
		if( sub==NULL )
		{	if( link )
			{	if( (p=strrchr(s,'/')) )	strcat(buf,p+1);
				else
				{	error("Nedefinovany \"subor\" (cyklicka linka)");
					return;
				}
			}
			else if( o->sekcia.nazov!=NULL )
			{	strcat(buf,o->sekcia.nazov);
				if( prip[0]!=0 )
				{	strcat(buf,".");
					strcat(buf,prip);
				}
			}
			else	buf[0]=0;
		}
		else	strcat(buf,sub);
		if( !link )
		{	if( buf[0]!=0 )
			{	if( text_exec!=NULL && zdrojsub!=NULL )
				{	if( fork()==0 )
					{	execlp(text_exec,text_exec,
							zdrojsub,buf,NULL);
						fprintf(stderr,"Error: Can't execute %s\n",text_exec);
						exit(1);
					}
					wait(NULL);
				}
				else	data2file(buf,s);
			}
			free(s);
		} else if( link==1 )
		{	linkfile(buf,s);
		} else if( link==3 )
		{	copyfile(buf,s);
		}
//		 else if( link==2 && sub!=NULL )
//			error("Nadbytocne definovny subor");
//		if( n==1 )	rs=s;
//		else
//			free(s);
		n++;
	}
	return;
}
